﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace QuantumEntanglement {
    public partial class frmPhotonicSensor: Form {
        public frmPhotonicSensor() {
            InitializeComponent();
        }

        public Bitmap my2D = null;

        public Random RND = new Random();


        public double getNoiseSignal() {
            //return RND.NextDouble()*200-100;   // -100 to +100
            double Q=RND.NextDouble()*20-10;   // -10 to +10
            return Q*Q*Q/System.Math.Abs(Q);    //-100 to +100
        }

        public void clear() {
            my2D=new Bitmap(pictureBox1.Size.Width,pictureBox1.Size.Height);
            Graphics g2=Graphics.FromImage(my2D);
            g2.Clear(Color.Black);
        }

        public double getThreshold() {
            return ((double)numericUpDown1.Value)*1.0f;  // 0 to 100percent 
        }






        public void Draw1D() {
            double thresh = getThreshold();
            Bitmap my1D=new Bitmap(pictureBox2.Size.Width, pictureBox2.Size.Height);
            Graphics g1=Graphics.FromImage(my1D);
            g1.Clear(Color.Black);
            int H = my1D.Height;
            int W = my1D.Width;
            double vScale = H/2.0/120;
            Pen P0 = new Pen(Color.Gray);
            Pen P1 = new Pen(Color.Yellow);
            Pen PT = new Pen(Color.Green);
            for(int i=0; i<W; i++) {
                double S = getNoiseSignal();
                if(System.Math.Abs(S)>thresh) {
                    g1.DrawLine(P1, (float)(i), (float)(H/2), (float)(i), (float)(H/2+vScale*S));
                } else {
                    g1.DrawLine(P0, (float)(i), (float)(H/2), (float)(i), (float)(H/2+vScale*S));
                }
            }
            g1.DrawLine(PT, 0, (float)(H/2+thresh*vScale), (float)W, (float)(H/2+thresh*vScale));
            g1.DrawLine(PT, 0, (float)(H/2-thresh*vScale), (float)W, (float)(H/2-thresh*vScale));
            if(pictureBox2.Image!=null) {
                pictureBox2.Image.Dispose();
            }
            pictureBox2.Image=my1D;
        }


        public void Update2D() {
            double fringMag = 0;
            if(cbFring.Checked) {
                fringMag=10;
            }
            double thresh = getThreshold();
            Graphics g1=Graphics.FromImage(my2D);
//            g1.Clear(Color.Black);
            int H = my2D.Height;
            int W = my2D.Width;
            double fringPeriod = 2*3.14159*5/W;
            Pen P0 = new Pen(Color.Yellow);
            Pen P1 = new Pen(Color.Red);
            Pen PT = new Pen(Color.Green);
            for(int i=0; i<W; i++) {
                for(int j=0; j<H; j++) {
                    double S = getNoiseSignal()+fringMag*System.Math.Cos(i*fringPeriod);
                    if(System.Math.Abs(S)>thresh) {
                        my2D.SetPixel(i, j, Color.Yellow);
                    }
                }
            }
            pictureBox1.Image=my2D;
        }


        public void Redraw() {
            if(my2D==null){
                clear();
            }
            Draw1D();
            Update2D();
        }





        private void timer1_Tick(object sender, EventArgs e) {
            Redraw();
        }

        private void button3_Click(object sender, EventArgs e) {
            clear();
        }
    }
}
